leetcode 1: 找出两个数相加等于给定数 two sum

问题描述

对于一个给定的数组,找出2个数,它们满足2个数的和等于一个特定的数,返回这两个数的索引。(从1开始)

Given an array of integers, find two numbers such that they add up to a specific target number.

The function twoSum should return indices of the two numbers such that they add up to the target,

where index1 must be less than index2. Please note that your returned answers (both index1 and index2)

are not zero-based.

You may assume that each input would have exactly one solution.

Input: numbers={2, 7, 11, 15}, target=9

Output: index1=1, index2=2

解决方案

1.思路分析:

我们将求2个数的索引转换成在数组中搜索(target-nums[i])的位置;

直观想,两层遍历,固定一个元素,循环右移另一个元素,逐个测试,时间复杂度$O(n^2)$,而$O(n^2)$一般不能接受,因此需要考虑改进算法:
想法则是降低到$O(n\ lgn)$,最理想则是$O(n)$

2.测试样例:

正数、负数、0

3.特殊情况:

数组不足2个数、两数相加溢出、没有匹配的情况

4.实现

4.1 两层遍历的实现:O(n2)

#include <iostream>
using namespace std;
int* twoSum(int* nums, int numsSize, int target, int* returnSize) {
    returnSize = NULL;
    if (numsSize < 2)
        return returnSize;
    int i = -1;
    int j;
    while (++i < numsSize-1) {
        if (nums[i] >= target)
            continue;
        j = i;
        while (++j < numsSize) {
            compare_times++;
            if (nums[i] + nums[j] == target)
                break;
        }
        if (j == numsSize)
            continue;
        else
            break;
    }
    if (i != numsSize-1) {
        returnSize = new int [2];
        returnSize[0] = i+1;
        returnSize[1] = j+1;
    }
    return returnSize;
}

int main()
{
    int nums[] = {-1, 0, 9, 5, 7, 11, 15, 20};
    int target = 9;
    int *index = NULL;
    index = twoSum(nums, sizeof(nums)/sizeof(nums[0]), target, index);
    if(index != NULL)
       cout<<"index1 = "<<index[0]<<", index2 = "<<index[1]<<endl;
}

提交到leetcode 返回Time Limit Exceeded,不满足时间要求。

4.2 排序实现 O(n lgn)

首先将数组进行快速排序或者插入到二叉搜索树中,二分查找,当固定一个元素nums[i],在数组中查找target - nums[i],此时查找时间降低到O(lg n),总消耗即为O(n lgn)

4.3 线性实现-Hash表 O(n)

我们知道对元素的搜索最快则是O(1),即直接索引到,联想只能是Hash表或者是关键字索引。关键字索引(从最小到最大)会占用额外的内存空间。

由于C++有现成的hash map,所以直接采用c++。

另外我们要求的是元素的索引,即Hash表的关键字,所以我们把数组元素作为Hash表的关键字,而把数组元素的索引作为Hash表的元素值。

class Solution
{
public:
    vector<int> twoSum(const vector<int> &nums, int target) {
        vector<int> results;
        if (nums.size() < 2) {
            return results;
        }
        map <int , int> hmap;
        //插入到hash map
        for (int i = 0; i < nums.size(); i++) {
            hmap.insert(pair <int, int> (nums[i], i) ); //元素值做关键值
        }
        int j;
        for (int i = 0; i < nums.size(); i++) {
            //hmap.count(x):x在hash map中出现的次数
            if (hmap.count(target - nums[i])) {
                j = hmap[(target - nums[i])];
                if (j < i) {
                    results.push_back(j+1);
                    results.push_back(i+1);
                }
            }
        }
        return results;
    }
};

测试

int main()
{
    int nums[] = {0,-3, 2, 7, 11, 15, 20};
    vector<int> nums_v(nums, nums+7);
    int target = 9;
    while (1) {
        class Solution sol;
        vector<int> results = sol.twoSum(nums_v, target);
        if(results.size())
            cout<<"index1 = "<<results[0]<<", index2 = "<<results[1]<<endl;
    }
    getchar();
}
时间: 2024-10-05 05:11:46

leetcode 1: 找出两个数相加等于给定数 two sum的相关文章

有两个变量a和b,不用“if”、“? :”、“switch”或其他判断语句,找出两个数中比较大的

1.问题 There are two int variables: a and b, don't use "if"."? :"."switch" or other judgement statement, find out the biggest one of the two numbers. (有两个变量a和b,不用"if"."? :"."switch"或其他判断语句,找出两个数中比较

java中请给出例子程序:找出两个数的最大公约数和最小公倍数

9.2 找出12和8的最大公约数和最小公倍数.    (视频下载) (全部书籍) public class Test {    public static void main(String[] args) {        getcommon_mu(12,8);        getcommon_div(12,8);    }//计算 最大公约数  和  最小公倍数    static void getcommon_mu(int n, int m) {        int i, b, d;  

LeetCode Add Two Numbers 两个数相加

1 /** 2 * Definition for singly-linked list. 3 * struct ListNode { 4 * int val; 5 * ListNode *next; 6 * ListNode(int x) : val(x), next(NULL) {} 7 * }; 8 */ 9 class Solution { 10 public: 11 ListNode *creatnode(int a){ 12 ListNode *nod=new ListNode(a);

找出k个数相加得n的所有组合

Find all possible combinations of k positive numbers that add up to a number n,each combination should be a unique set of numbers. 1 /** 2 * Return an array of arrays of size *returnSize. 3 * The sizes of the arrays are returned as *columnSizes array

[LeetCode] 3Sum 找出所有三个元素之和为0的组合

本题是查找两个数使和为给定值的变形. 一开始采用的是维护两个下标(即目标三元组中的最小值和最大值),两边向中间逼近.针对两个下标,利用二分法找出介于二者之间的数.写完之后,有个数据过不去,原因在于两个下标有可能需要往外移动,而非仅仅是逼近,如: [-4,-2,-2,-2,0,1,2,2,2,3,3,4,4,6,6] 三元组(-2,1,3)的下一个是(-2,-2,4),此时下标由3回复到4,而非往下移. 原因:x+y+z=0, x↑, z可能增或减. 正确做法: 只是在经典问题上做改进.枚举最小值

算法题:三个数相加等于某个特定值

题目来自于leetcode第十五题 给定一个n个整数的数组S,是否存在S中的元素a,b,c,使得a + b + c = 0? 查找数组中所有唯一的三元组,它们的总和为零. 注意:解决方案集不能包含重复的三元组. 例子: 给定数组:S = [-1, 0, 1, 2, -1, -4], 解决方案:[[-1, 0, 1],[-1, -1, 2]]. 在刚看到这道题目的题目的时候,首先想到的就是暴力解法,将数组排序后直接嵌套三个循环,这样子虽然简单,但是时间复杂度确实n^3,遇到数据量过大的时候消耗太大

在给定数组中,找出最先满足两个数的和等于给定数,输出这两个元素的下表

leetcode上的一道题目,虽然不难,但是考察了数据结构中很多的知识 Given an array of integers, find two numbers such that they add up to a specific target number. The function twoSum should return indices of the two numbers such that they add up to the target, where index1 must be

题目:一个数如果恰好等于它的因子之和,这个数就称为 &quot;完数 &quot;。例如6=1+2+3.编程&#160;&#160;&#160;&#160; 找出1000以内的所有完数。

题目:一个数如果恰好等于它的因子之和,这个数就称为 "完数 ".例如6=1+2+3.编程     找出1000以内的所有完数. 1 package day11_2; 2 3 public class lianxi09 { 4 public static void main(String[] args) { 5 6 for (int i = 1; i < 1000; i++) { 7 int sum=0; 8 for (int j = 1; j <i; j++) { 9 10

一个数如果恰好等于它的因子之和,这个数就称为&quot;完数&quot;。 例如,6的因子为1、2、3,而6=1+2+3,因此6是&quot;完数&quot;。 编程序找出N之内的所有完数,

题目描述 一个数如果恰好等于它的因子之和,这个数就称为"完数". 例如,6的因子为1.2.3,而6=1+2+3,因此6是"完数". 编程序找出N之内的所有完数,并按下面格式输出其因子: 输入 N 输出 ? its factors are ? ? ? 样例输入 1000 样例输出 6 its factors are 1 2 3 28 its factors are 1 2 4 7 14 496 its factors are 1 2 4 8 16 31 62 124